{
  description = "A game stub written in Haskell";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = nixpkgs.legacyPackages.${system};

        haskellPackages = pkgs.haskellPackages;

        jailbreakUnbreak = pkg:
          pkgs.haskell.lib.doJailbreak (pkg.overrideAttrs (_: { meta = { }; }));

        packageName = "vulkan-tutorial";
      in rec {
        packages.${packageName} = # (ref:haskell-package-def)
          haskellPackages.callCabal2nix packageName self rec {
            # Dependency overrides go here
            wavefront = jailbreakUnbreak haskellPackages.wavefront;
          };

        defaultPackage = self.packages.${system}.${packageName};

        devShell = haskellPackages.shellFor {
          packages = p: [ defaultPackage ];
          withHoogle = true;
          buildInputs = (with haskellPackages; [
            haskell-language-server
            ghcid
            cabal-install
          ]) ++ (with pkgs; [
            shaderc
          ]);
        };
        #devShell = pkgs.mkShell {
        #  buildInputs = with haskellPackages; [
        #    haskell-language-server
        #    ghcid
        #    cabal-install
        #  ];
        #  nativeBuildInputs = with pkgs; [
        #    pkg-config
        #    SDL2
        #    vulkan-validation-layers
        #    vulkan-headers
        #    vulkan-loader
        #  ];
        #  inputsFrom = builtins.attrValues self.packages.${system};
        #};
      });
}

